const strips = [...document.querySelectorAll(".strip")];
const numberSize = "4"; // in rem

var lastTime = new Array(-1, -1, -1)
var Hour12 = true;
//only works for Wallpaper Engine
var wait = true;

// highlight number i on strip s for 1 second
function highlight(strip, d) {
    strips[strip]
        .querySelector(`.number:nth-of-type(${d + 1})`)
        .classList.add("pop");

    setTimeout(() => {
        strips[strip]
            .querySelector(`.number:nth-of-type(${d + 1})`)
            .classList.remove("pop");
    }, 950); // causes ticking
}
function stripSlider(strip, id, number) {
    let d1 = Math.floor(number / 10);
    let d2 = number % 10;

    if (lastTime[id] == -1 || lastTime[id] != number) {
        strips[strip].style.transform = `translateY(${d1 * -numberSize}rem)`;
        strips[strip + 1].style.transform = `translateY(${d2 * -numberSize}rem)`;

        lastTime[id] = number;
    }
	if (id != 100){
    highlight(strip, d1);
	}
	highlight(strip + 1, d2);
}

window.wallpaperPropertyListener = {
	applyUserProperties: function (properties) {
	  wait = false
	  if (properties.Hour12) {
		if (properties.Hour12.value) {
		  hour_12(false);
		  document.getElementById("AMPM").style.display = "none";
		  updateClock();
		} else {
		  hour_12(true);
		  document.getElementById("AMPM").style.display = "inline";
		  updateClock();
		};
	  };
	}
}

function updateClock() {
	
    // get new time
    const time = new Date();

    // get h,m,s
	if (wait == false){
		var hours = time.getHours();
		if (Hour12 == true) {
			if (hours > 12) {
				var hours = hours - 12;
				stripSlider(5, 100 , 1);
			} else if (hours === 0) {
			   var hours = 12;
			   stripSlider(5, 100, 0);
			} else {
				stripSlider(5, 100 , 0);
			}
		} else {
			
		}
		const mins = time.getMinutes();
		var secs = time.getSeconds();

		// slide strips
		stripSlider(0, 0, hours);
		stripSlider(2, 1, mins);
		stripSlider(4, 2, secs);
	}
}

function hour_12(bo) {
setTimeout(function () {
  clock();
}, 1);
return Hour12 = bo;
};

// set Timer for clock-update

setInterval(updateClock, 100);

updateClock();
